
var gProfilerService = Components.classes['@yahoo.com/YJSProfiler;1']
					.getService(Components.interfaces.nsIYJSProfiler);


function LOG(msg)
{
  var consoleService = Components.classes["@mozilla.org/consoleservice;1"].getService(Components.interfaces.nsIConsoleService);
  consoleService.logStringMessage(msg);
}

function onLoad(event) {
  try {
  	var prefs = Components.classes[ "@mozilla.org/preferences-service;1" ]
  					.getService(Components.interfaces.nsIPrefBranch );
     var profilingEnabled = prefs.getBoolPref( "extensions.ybookmarks@yahoo.debug" );
  	 gProfilerService.initProfiler("DelProfiling.xml",profilingEnabled);
  } catch (e) {
  	LOG("Error in yInitProfiler::onLoad()");
  }
}

function onUnload(event) {
  try {
     gProfilerService.deInitProfiler();
  } catch (e) {
		LOG("Error in yInitProfiler::onUnLoad()");
  }
}


window.addEventListener("load", onLoad, false);
window.addEventListener("unload", onUnload, false);


